//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
#import "kernel32.dll"
int  CreateFileW(string name,int desiredAccess,int SharedMode,int security,int creation,int flags,int templateFile);
int  ReadFile (int fileHandle,char& buffer[],int bytes,int& numOfBytes,int overlapped);
int  WriteFile(int fileHandle,char& buffer[],int bytes,int& numOfBytes,int overlapped);
int  CloseHandle(int fileHandle);
bool DeleteFileW(string filename);
int  GetLastError(void);
int  FlushFileBuffers(int pipeHandle);
#import


static const uint GENERIC_READ     = 0x80000000;
static const uint GENERIC_WRITE    = 0x40000000;

static const int SHARE_READ        = 1;
static const int SHARE_DELETE      = 4;

static const int CREATE_ALWAYS     = 2;
static const int OPEN_EXISTING     = 3;
static const int OPEN_CREATE       = 4;

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
  string filename = "c:/temp/test-file.txt";
  
  DeleteFileW(filename);
  
  int h = CreateFileW(filename,
                      (int)GENERIC_READ|GENERIC_WRITE,
                      SHARE_READ|SHARE_DELETE, 0, CREATE_ALWAYS, 0, 0);
  if (h < 0)
  {
    PrintFormat("Error: %d", kernel32::GetLastError());
    return;
  }
  
  char buf[];
  int  sz = StringToCharArray("test", buf);
  int  written, read;
  
  int  n = WriteFile(h, buf, sz-1, written, 0);
  
  PrintFormat("n = %d, written = %d (h: %d)", n, written, h);
  
  CloseHandle(h);
  
  h = CreateFileW(filename, (int)GENERIC_READ,
                  SHARE_READ|SHARE_DELETE, 0, OPEN_EXISTING, 0, 0);
  
  sz = 256;
  ArrayResize(buf, sz);

  n = ReadFile(h, buf, sz, read, 0);
  
  string s = n > 0 ? CharArrayToString(buf, 0, read) : "";
  PrintFormat("Read = %s (%d, %d)", s, read, n);
  
  CloseHandle(h);
}
//+------------------------------------------------------------------+
